import { Menu } from '@alifd/next';
import { parseContextMenuAsReactNode, parseContextMenuProperties } from '@alilc/lowcode-utils';
import { engineConfig } from '@alilc/lowcode-editor-core';
import React from 'react';
export function ContextMenu(_ref) {
  var children = _ref.children,
    menus = _ref.menus;
  if (!engineConfig.get('enableContextMenu')) {
    return /*#__PURE__*/React.createElement(React.Fragment, null, children);
  }
  var handleContextMenu = function handleContextMenu(event) {
    event.preventDefault();
    event.stopPropagation();
    var target = event.target;
    var _target$getBoundingCl = target === null || target === void 0 ? void 0 : target.getBoundingClientRect(),
      top = _target$getBoundingCl.top,
      left = _target$getBoundingCl.left;
    var destroyFn;
    var destroy = function destroy() {
      var _destroyFn;
      (_destroyFn = destroyFn) === null || _destroyFn === void 0 ? void 0 : _destroyFn();
    };
    var children = parseContextMenuAsReactNode(parseContextMenuProperties(menus, {
      destroy: destroy
    }));
    if (!(children !== null && children !== void 0 && children.length)) {
      return;
    }
    var menuInstance = Menu.create({
      target: event.target,
      offset: [event.clientX - left, event.clientY - top],
      children: children
    });
    destroyFn = menuInstance.destroy;
  };

  // 克隆 children 并添加 onContextMenu 事件处理器
  var childrenWithContextMenu = React.Children.map(children, function (child) {
    return /*#__PURE__*/React.cloneElement(child, {
      onContextMenu: handleContextMenu
    });
  });
  return /*#__PURE__*/React.createElement(React.Fragment, null, childrenWithContextMenu);
}