"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.ContextMenu = ContextMenu;
var _next = require("@alifd/next");
var _lowcodeUtils = require("@alilc/lowcode-utils");
var _lowcodeEditorCore = require("@alilc/lowcode-editor-core");
var _react = _interopRequireDefault(require("react"));
function ContextMenu(_ref) {
  var children = _ref.children,
    menus = _ref.menus;
  if (!_lowcodeEditorCore.engineConfig.get('enableContextMenu')) {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, children);
  }
  var handleContextMenu = function handleContextMenu(event) {
    event.preventDefault();
    event.stopPropagation();
    var target = event.target;
    var _target$getBoundingCl = target === null || target === void 0 ? void 0 : target.getBoundingClientRect(),
      top = _target$getBoundingCl.top,
      left = _target$getBoundingCl.left;
    var destroyFn;
    var destroy = function destroy() {
      var _destroyFn;
      (_destroyFn = destroyFn) === null || _destroyFn === void 0 ? void 0 : _destroyFn();
    };
    var children = (0, _lowcodeUtils.parseContextMenuAsReactNode)((0, _lowcodeUtils.parseContextMenuProperties)(menus, {
      destroy: destroy
    }));
    if (!(children !== null && children !== void 0 && children.length)) {
      return;
    }
    var menuInstance = _next.Menu.create({
      target: event.target,
      offset: [event.clientX - left, event.clientY - top],
      children: children
    });
    destroyFn = menuInstance.destroy;
  };

  // 克隆 children 并添加 onContextMenu 事件处理器
  var childrenWithContextMenu = _react["default"].Children.map(children, function (child) {
    return /*#__PURE__*/_react["default"].cloneElement(child, {
      onContextMenu: handleContextMenu
    });
  });
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, childrenWithContextMenu);
}